/**********************************************************************/
/* The Minstrel's Song is (c) 1998 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.            */
/**********************************************************************/


#include <math.h>
#include "tms.h"

void calculator()
    {
    long i, j, curr_x, curr_y, command, my_continue, button, char_continue, 
      register1, register2, my_error, hitbutton, prevbutton;
    button = 0;
    curr_x = curr_y = 0;
    register1 = register2 = 0;
    my_error = hitbutton = FALSE;
    prevbutton = '=';
    clear();
    refresh();
    pmsg("You are now using a calculator; hit \'?\' for help...");
    /* The main loop.  */
    for(my_continue=1;(my_continue);)
	{
	/* Draw the calculator.  */
	if (my_error)
	    mvwprintw(puzzle, 0, 0, "   E");
	else if ((-1 < register1) && (register1 < 10))
	    mvwprintw(puzzle, 0, 0, "   %ld", register1);
	else if ((-10 < register1) && (register1 < 100))
	    mvwprintw(puzzle, 0, 0, "  %ld", register1);
	else if ((-100 < register1) && (register1 < 1000))
	    mvwprintw(puzzle, 0, 0, " %ld", register1);
	else
	    mvwprintw(puzzle, 0, 0, "%ld", register1);
	for(i=0;i<CALCULATOR_X;++i)
	    for(j=0;j<CALCULATOR_Y;++j)
		mvwaddch(puzzle, j + 1, i, calculator_image[i][j]);
	wmove(puzzle, curr_y + 1, curr_x);
	wrefresh(puzzle);
	char_continue = TRUE;
	for(command=tgetc();(char_continue);)
	    {
	    switch(command)
		{
		case LEFT: --curr_x; break;
		case DOWN: ++curr_y; break;
		case UP: --curr_y; break;
		case RIGHT: ++curr_x; break;
		case UP_LEFT: --curr_x; --curr_y; break;
		case UP_RIGHT: ++curr_x; --curr_y; break;
		case DOWN_LEFT: --curr_x; ++curr_y; break;
		case DOWN_RIGHT: ++curr_x; ++curr_y; break;
		case '?':
		    pmsg("Use the directional motion keys to move the cursor \
about on the keypad, and");
		    nocap_pmsg("hit '.' to press a button.");
		    pmsg("Alternately, type a key on your keyboard to press \
the corresponding button.");
		    pmsg("Hit ESCAPE to stop using the calculator.");
		break;
		case '0': case '1': case '2': case '3': case '4': case '5':
		case '6': case '7': case '8': case '9': case '+': case '-':
		case '*': case '/': case '=': case 'C':
		    char_continue = FALSE;
		    button = command;
		break;
		case 'c':
		    char_continue = FALSE;
		    button = 'C';
		break;
		case '.':
		    char_continue = FALSE;
		    button = calculator_image[curr_x][curr_y];
		break;
		case ESCAPE: case 'q': case 'Q':
		    pmsg("You put the calculator away.");
		    char_continue = FALSE;
		    button = command;
		break;
		}
	    curr_x = max(curr_x, 0);
	    curr_x = min(curr_x, CALCULATOR_X - 1);
	    curr_y = max(curr_y, 0);
	    curr_y = min(curr_y, CALCULATOR_Y - 1);
	    wmove(puzzle, curr_y + 1, curr_x);
	    wrefresh(puzzle);
	    if (char_continue)
		command = tgetc();
	    }
	if ((command == ESCAPE) || (command == 'q') || (command == 'Q'))
	    my_continue = 0;
	else
	    {
	    if ((button >= '0') && (button <= '9'))
		{
		if (hitbutton)
		    {
		    hitbutton = FALSE;
		    register2 = register1;
		    register1 = button - '0';
		    }
		else
		    register1 = (10 * register1) + button - '0';
		}
	    else if ((hitbutton) && (prevbutton != '='))
		{
		register1 = register2 = 0;
		my_error = TRUE;
		}
	    else
		{
		hitbutton = TRUE;
		switch(prevbutton)
		    {
		    case '+':
		        register2 += register1;
		    break;
		    case '-':
		        register2 -= register1;
		    break;
		    case '*':
		        register2 *= register1;
		    break;
		    case '/':
			if (register1 != 0)
			    register2 /= register1;
			else
			    my_error = TRUE;
		    break;
		    case '=':
		        register2 = register1;
		    break;
		    }
		register1 = register2;
		prevbutton = button;
		}
	    if (button == 'C')
		{
		register2 = register1 = 0;
		my_error = FALSE;
		}
	    register1 = min(9999, max(register1, -999));
	    register2 = min(9999, max(register2, -999));
	    }
	}
    }
