/**********************************************************************/
/* The Minstrel's Song is (c) 1998 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.            */
/**********************************************************************/

#include "tms.h"

/* This file has the inventory related functions. */

void pickup(struct small_creature *c)

/* Have a creature pick up any or all items where he is, after checking if he
wants them.  Puts the item at the end of the list of possessions.  Also check
for money.  */

    {
    struct ilist *curr_item, *prev_item, *other_item;
    char message[256], item_name[256];
    long my_continue;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if ((current_level->space[c->x][c->y].items!=NULL) && (current_level !=
      countryside))
	{
	for(prev_item=curr_item=current_level->space[c->x][c->y].items;
	    (!(curr_item==NULL)); curr_item=curr_item->next)
	    {
	    if (!(flag_check(curr_item->current->flags2, I_NO_PICKUP)))
		{
		if (wants(c, curr_item->current))
		    {
		    if ((current_level->level_type == LEVEL_CAVERN) &&
		      (curr_item->current->identity == FIRESTAR))
			flag_set(&game_variables->quests_completed,
			  COMPLETED_DUNGEON);
		    if ((current_level->level_type == LEVEL_MANSION) &&
		      (current_level->power_level == 0 - 3) &&
		      (curr_item->current->identity == SPIDER_SILK_ROBE))
			flag_set(&game_variables->quests_completed,
			  EXPLORED_MANSION);
		    if ((current_level->level_type == LEVEL_MAZE) &&
		      (curr_item->current->identity == DIAMOND_CHALICE))
			flag_set(&game_variables->quests_completed,
			  EXPLORED_MISTRELLI);
		    if ((current_level->level_type == LEVEL_OCEAN_ISLE) &&
		      (curr_item->current->identity == PEARL_OF_GREAT_PRICE))
			flag_set(&game_variables->quests_completed,
			  EXPLORED_OCEAN);
		    if (!(curr_item->current->name == ST_DEFAULT))
			find_string(curr_item->current->name, item_name);
		    else if ((!(curr_item->current->tname == NULL)) &&
		      ((!(flag_check(curr_item->current->flags2,
		      DONT_PRINT_NAME_UNLESS_IDENTIFIED))) ||
		      (flag_check(curr_item->current->flags, IDENTIFIED))))
			strcpy(item_name, curr_item->current->tname->text);
		    else if (flag_check(curr_item->current->flags, IDENTIFIED))
			strcpy(item_name,
			  orig_items[curr_item->current->identity].identified);
		    else
			strcpy(item_name,
			  orig_items[curr_item->current->identity].nonidentified);
		    if (!(prev_item==curr_item))
			{
			prev_item->next=curr_item->next;
			curr_item->next=NULL;
			add_item_join(&c->extended->pack, &curr_item->current);
			free(curr_item);
			}
		    else
			{
			current_level->space[c->x][c->y].items=
			  current_level->space[c->x][c->y].items->next;
			curr_item->next=NULL;
			if (c->extended->pack == NULL)
			    c->extended->pack=curr_item;
			else if (c->extended->pack->next==NULL)
			    c->extended->pack->next=curr_item;
			else
			    {
			    for(other_item=c->extended->pack;
			      (!(other_item->next==NULL));
			      other_item=other_item->next);
			    other_item->next=curr_item;
			    }
			prev_item=current_level->space[c->x][c->y].items;
			}
		    calc_ready(c);
		    if (can_see(player, c->x, c->y) || (c == player))
			{
			find_title(c, message);
			strcat(message, " pick");
			if (!(c == player))
			    strcat(message, "s");
			strcat(message, " up the ");
			strcat(message, item_name);
			strcat(message, ".");
			pmsg(message);
			}
		    check_use(c, curr_item->current);
		    }
		}
	    else
		prev_item=curr_item;
	    }
	}
    if (c == player)
/* Eventually, other creatures may pick up money as well.  */
	if ((current_level->space[c->x][c->y].cu > 0) ||
	    (current_level->space[c->x][c->y].si > 0) ||
	    (current_level->space[c->x][c->y].el > 0) ||
	    (current_level->space[c->x][c->y].au > 0))
	    {
	    if (flag_check(game_variables->flags, CONFIRM_WHEN_IN_DOUBT))
		{
		pmsg("There is money here; do you wish to pick it up?");
		my_continue = confirm_silent();
		}
	    else
		my_continue = TRUE;
	    if (my_continue)
		{
		if (current_level->space[c->x][c->y].cu > 0)
		    {
		    sprintf(message, "You pick up %ld copper piece",
		      current_level->space[c->x][c->y].cu);
		    if (current_level->space[c->x][c->y].cu > 1)
			strcat(message, "s");
		    strcat(message, ".");
		    pmsg(message);
		    c->extended->cu += current_level->space[c->x][c->y].cu;
		    current_level->space[c->x][c->y].cu = 0;
		    }
		if (current_level->space[c->x][c->y].si > 0)
		    {
		    sprintf(message, "You pick up %ld silver piece",
		      current_level->space[c->x][c->y].si);
		    if (current_level->space[c->x][c->y].si > 1)
			strcat(message, "s");
		    strcat(message, ".");
		    pmsg(message);
		    c->extended->si += current_level->space[c->x][c->y].si;
		    current_level->space[c->x][c->y].si = 0;
		    }
		if (current_level->space[c->x][c->y].el > 0)
		    {
		    sprintf(message, "You pick up %ld electrum piece",
		      current_level->space[c->x][c->y].el);
		    if (current_level->space[c->x][c->y].el > 1)
			strcat(message, "s");
		    strcat(message, ".");
		    pmsg(message);
		    c->extended->el += current_level->space[c->x][c->y].el;
		    current_level->space[c->x][c->y].el = 0;
		    }
		if (current_level->space[c->x][c->y].au > 0)
		    {
		    sprintf(message, "You pick up %ld gold piece",
		      current_level->space[c->x][c->y].au);
		    if (current_level->space[c->x][c->y].au > 1)
			strcat(message, "s");
		    strcat(message, ".");
		    pmsg(message);
		    c->extended->au += current_level->space[c->x][c->y].au;
		    current_level->space[c->x][c->y].au = 0;
		    }
		calc_ready(c);
		}
	    }
    }


void wear_wield_internal(struct small_creature *c, struct small_item *i)

/* Have creature c attempt to wear or wield an item */

    {
    struct ilist *previous, *current, *traverse;
    char message[256], mymessage[256];
    long conflict, first, second_last, last, j;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    conflict=0;
    strcpy(message, "");
    if (!(c->extended->wear_wield==NULL))
	{
	for(current=c->extended->wear_wield; (!(current==NULL)); current =
	  current->next)
	    if (flag_check(orig_items[current->current->identity].slots,
	      orig_items[i->identity].slots))
		{
		conflict = 1;
		if (c == player)
		    {
		    strcpy(message, "The ");
		    description(i,mymessage);
		    strcat(message, mymessage);
		    strcat(message, " and the ");
		    description(current->current,mymessage);
		    strcat(message, mymessage);
		    strcat(message, " both need your ");
		    first = second_last = last = 0;
		    for (j=1; j <= LAST_SLOT; j *= 2)
			if (flag_check(orig_items[current->current->identity]
			  .slots & orig_items[i->identity].slots, j))
			    {
			    if (first == 0)
				first = second_last = last = j;
			    else
				{
				second_last = last;
				last = j;
				}
			    }
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, FEET))
			{
			if (!(first==FEET))
			    {
			    if (last > FEET)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			strcat(message, "feet");
			}
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, FOREARMS))
			{
			if (!(first==FOREARMS))
			    {
			    if (last > FOREARMS)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			strcat(message, "forearms");
			}
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, PRIMARY_HAND))
			{
			if (!(first==PRIMARY_HAND))
			    {
			    if (last > PRIMARY_HAND)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			if (flag_check(game_variables->flags, INV_LEFT_HANDED))
			    strcat(message, "left");
			else
			    strcat(message, "right");
			strcat(message, " hand");
			}
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, SECONDARY_HAND))
			{
			if (!(first==SECONDARY_HAND))
			    {
			    if (last > SECONDARY_HAND)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			if (flag_check(game_variables->flags, INV_LEFT_HANDED))
			    strcat(message, "right");
			else
			    strcat(message, "left");
			strcat(message, " hand");
			}
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, HEAD))
			{
			if (!(first==HEAD))
			    {
			    if (last > HEAD)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			strcat(message, "head");
			}
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, S_CLOAK))
			{
			if (!(first==S_CLOAK))
			    {
			    if (last > S_CLOAK)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			strcat(message, "body");
			}
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, ARMOR))
			{
			if (!(first==ARMOR))
			    {
			    if (last > ARMOR)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			strcat(message, "torso");
			}
		    if (flag_check(orig_items[current->current->identity].slots
		      & orig_items[i->identity].slots, VEHICLE))
			{
			if (!(first==VEHICLE))
			    {
			    if (last > VEHICLE)
				{
				strcat(message, ", ");
				}
			    else
				{
				if (first == second_last)
				    strcat(message, " and ");
				else
				    strcat(message, ", and ");
				}
			    }
			strcat(message, "use as vehicle");
			}
		    strcat(message, ".");
		    pmsg(message);
		    }
		}
	}
    conflict |= (!(flag_check(i->flags, WEAR_WIELD)));
    if (!(conflict==1))
	{
	/* Wear or wield it */
	current = (struct ilist *) calloc(1, sizeof(struct ilist));
#ifdef DEBUG
	current->me = current;
#endif
	current->current = i;
	current->next = NULL;
	if (!(c->extended->wear_wield == NULL))
	    {
	    for(traverse = c->extended->wear_wield;(!(traverse==NULL));
	      traverse=traverse->next)
		previous=traverse;
	    previous->next = current;
	    }
	else
	    c->extended->wear_wield = current;
		description(i, mymessage);
	sprintf(message, "You are now using your %s.", mymessage);
	if (c == player)
	    pmsg(message);
	}
    else
	{
	/* Put it in the creature's pack.  */
	current = (struct ilist *) calloc(1, sizeof(struct ilist));
#ifdef DEBUG
	current->me = current;
#endif
	current->current = i;
	current->next = NULL;
	if (!(c->extended->pack == NULL))
	    {
	    for(traverse = c->extended->pack;(!(traverse==NULL));
	      traverse=traverse->next)
	          previous=traverse;
	    previous->next = current;
	    }
	else
	    c->extended->pack = current;
	if (c==player)
	    {
	    pmsg("You put it in your pack...");
	    }
	}
    calc_ready(c);
    }

void wear_wield(struct small_creature *c)
    {
    struct ilist *traverse, *previous, *current;
    struct small_item *target_item;
    long temp;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    temp = 'a';
    pmsg("Please enter the letter of the item you wish to wear or wield.");
    target_item = extract_item(&c->extended->pack, 'a', &temp, tgetc(),
      EXTRACT_REMOVE_ITEM|EXTRACT_RECURSIVE);
    find_and_remove_item(target_item, &c->extended->pack);
    if (target_item == NULL)
	pmsg("That is not a valid item.");
    else
	{
	if (flag_check(target_item->flags, WEAR_WIELD))
	    wear_wield_internal(c, target_item);
	else
	    {
	    pmsg("You cannot equip that item in that manner.");
	    current = (struct ilist *) calloc(1, sizeof(struct ilist));
#ifdef DEBUG
	    current->me = current;
#endif
	    current->current = target_item;
	    current->next = NULL;
	    if (!(c->extended->pack == NULL))
		{
		for(traverse = c->extended->pack;(!(traverse==NULL));
		  traverse=traverse->next)
		    previous=traverse;
		previous->next = current;
		}
	    else
		c->extended->pack = current;
	    if (c==player)
		{
		pmsg("You put it in your pack...");
		}
	    }
	}
    }

void drop_item(struct small_creature *c)
    {
    struct ilist *traverse, *previous, *current;
    struct small_item *target_item;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    pmsg("Please enter the letter of the item you wish to drop.");
    target_item = get_item(c, EXTRACT_REMOVE_ITEM|EXTRACT_RECURSIVE);
    if (target_item == NULL)
	pmsg("That is not a valid item.");
    else
	{
	current = (struct ilist *) calloc(1, sizeof(struct ilist));
#ifdef DEBUG
	current->me = current;
#endif
	current->current = target_item;
	current->next = NULL;
	if (!(current_level->space[c->x][c->y].items == NULL))
	    {
	    for(traverse = current_level->space[c->x][c->y].items;
	        (!(traverse==NULL));
	        traverse=traverse->next)
	        previous=traverse;
	        previous->next = current;
	    }
	else
	current_level->space[c->x][c->y].items = current;
	if (c==player)
	    {
	    pmsg("Dropped.");
	    }
	}
    calc_ready(c);
    }

void unequip(struct small_creature *c)
    {
    struct ilist *traverse, *previous, *current;
    struct small_item *target_item;
    long temp;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    temp = 'a';
    pmsg("Please enter the letter of the item you wish to remove.");
    target_item = extract_item(&c->extended->wear_wield, 'a', &temp, tgetc(),
      EXTRACT_REMOVE_ITEM);
    find_and_remove_item(target_item, &c->extended->wear_wield);
    if (target_item == NULL)
	pmsg("That is not a valid item.");
    else
	{
	current = (struct ilist *) calloc(1, sizeof(struct ilist));
#ifdef DEBUG
	current->me = current;
#endif
	current->current = target_item;
	current->next = NULL;
	if (!(c->extended->pack == NULL))
	    {
	    for(traverse = c->extended->pack;(!(traverse==NULL));
	      traverse=traverse->next)
		previous=traverse;
	    previous->next = current;
	    }
	else
	    c->extended->pack = current;
	if (c==player)
	    {
	    pmsg("You put it in your pack...");
	    }
	}
    }


long wants(struct small_creature *c, struct small_item *i)

/* Determine if a creature wants an item */

    {
    char message[256], item_name[256];
    long desired;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
    check_pointer((struct pointer_struct *) i);
#endif
    desired=0;
    if ((c != NULL) && (i != NULL))
	{
	item_desc(i, item_name);
        if (c==player)
	    {
	    if (flag_check(game_variables->flags, ASK_PICKUP))
		{
		sprintf(message, "Pick up the ");
		strcat(message, item_name);
		strcat(message, "?");
		pmsg(message);
		desired=confirm_silent();
		}
	    else
		desired = 1;
		}
	    }
	else
	    {
	    if (!(c->extended == NULL))
		{
		if ((is_hungry(c)) && (orig_items[i->identity].effect ==
		  E_FOOD) && (!(c->identity < NUM_RACES) && ((strcmp(item_name,
		  "corpse")) || strcmp(item_name, "body"))))
		    desired = 1;
		}
	}
    return desired;
    }

void check_use(struct small_creature *c, struct small_item *i)

/* Determine if a creature will use an item. */

    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    if ((is_hungry(c)) && (orig_items[i->identity].effect == E_FOOD))
	use_item(c, i);
    if ((is_thirsty(c)) && ((orig_items[i->identity].effect == ALCOHOL) ||
      (orig_items[i->identity].effect == QUENCH_THIRST)))
	use_item(c, i);
    }

struct small_item *find_item(struct ilist **i, long letter_to_retrieve, long
  flags)
    {
    long letter;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) *i);
#endif
    letter = 'a';
    return extract_item(i, 'a', &letter, letter_to_retrieve, flags);
    }

struct small_creature *find_creature(struct clist *cl, long letter_to_retrieve)
    {
    long i;
    struct clist *traverse;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) cl);
#endif
    traverse = cl;
    for(i='a';(!((i == letter_to_retrieve)||(i == '?'))); i = successor(i))
	if (!(traverse == NULL))
	    traverse = traverse->next;
    if (!(traverse == NULL))
	return traverse->current;
    else
	return NULL;
    }

struct small_creature *extract_creature(struct clist **cl, long
  letter_to_retrieve)
    {
    long i;
    struct clist *traverse, *previous;
    struct small_creature *result;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) cl);
#endif
    traverse = previous = *cl;
    result = NULL;
    for(i='a';(!((i == letter_to_retrieve)||(i == '?'))); i = successor(i))
	if (!(traverse == NULL))
	    {
	    previous = traverse;
	    traverse = traverse->next;
	    }
    if (!(traverse == NULL))
	{
	if (!(traverse == previous))
	    {
	    previous->next = traverse->next;
	    result = traverse->current;
	    free(traverse);
	    }
	else /* first creature on the list.  */
	    {
	    *cl = (*cl)->next;
	    result = traverse->current;
	    free(traverse);
	    }
	}
    return result;
    }

/* Remove an item from a creature's inventory.  For now, we don't worry about */
/* translucent containers that aren't open.  */

struct small_item *extract_item(struct ilist **i, long start_letter, long
  *current_letter, long letter_to_retrieve, long flags)
    {
    struct ilist *current;
    struct small_item *result, *candidate;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) *i);
#endif
    result = candidate = NULL;
    if (*i!=NULL)
	{
	for (current = *i; (!(current==NULL));)
	    {
	    if (*current_letter == letter_to_retrieve)
		{
		result = current->current;
		current = NULL;
		}
	    else
		{
		*current_letter = successor(*current_letter);
		if (flag_check(flags, EXTRACT_RECURSIVE))
		    {
		    if ((current->current->contents!=NULL) &&
		      (((flag_check(current->current->flags, IS_OPEN)) ||
		      (!(flag_check(current->current->flags, CAN_OPEN)))) ||
		      (flag_check(current->current->flags, TRANSLUCENT))))
			{
			candidate = extract_item(&current->current->contents,
			  start_letter, current_letter, letter_to_retrieve,
			    flags);
			}
		    if (candidate!=NULL)
			{
			result = candidate;
			current = NULL;
			}
		    }
		}
	    if (current!=NULL)
		current = current->next;
	    }
	}
    return result;
    }

void print_ilist_internal(struct ilist *i, long indent, long *curr_letter, long flags)
    {
    struct ilist *current;
    char message[256], post_script[256], item_name[256], temp[256],
    myresult[256];
    long j, first, second_last, last, success;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) i);
#endif
    success = 1;
    if (!(i==NULL))
	{
	for (current=i; (!(current==NULL)); current = current->next)
	    {
	    item_desc(current->current, item_name);
	    if (flag_check(flags, LETTER_ITEMS))
		sprintf(message, "%c: ", (char) *curr_letter);
	    else
		strcpy(message, "");
	    strcpy(post_script, "");
	    /* The order of letters is lowercase, then uppercase, then just a
	       question mark.  */
	    *curr_letter = successor(*curr_letter);
	    for(j = 0; j < indent; ++j)
	        strcat(message, " ");
            if (!(flag_check(current->current->flags2, SOME)))
		{
		if (current->current->number == 1)
		    {
		    if ((item_name[0]=='a') ||
			(item_name[0]=='e') ||
			(item_name[0]=='i') ||
			(item_name[0]=='o') ||
			(item_name[0]=='u'))
			strcat(message, "an ");
		    else
			strcat(message, "a ");
		    }
		else 
		    {
		    sprintf(temp, "%ld ", current->current->number);
		    strcat(post_script, "s");
		    }
		}
	    else
		{
		strcat(message, "some ");
		}
	    strcat(message, item_name);
	    strcat(message, post_script);
	    if (flag_check(flags, LIST_PRICES))
		{
		strcat(message, " (");
		if (!(flag_check(current->current->flags2, HAGGLED)))
		    strcat(message, "asking ");
		money_string(current->current->price, myresult);
		strcat(message, myresult);
		strcat(message, ")");
		}
	    if ((flag_check(flags, LIST_SLOTS)) &&
	      (!(orig_items[current->current->identity].slots==0)))
		{
		strcat(message, " (on ");
		first = second_last = last = 0;
		for (j=1; j <= LAST_SLOT; j *= 2)
		    if (flag_check(orig_items[current->current->identity].slots,
		      j))
			{
			if (first == 0)
			    first = second_last = last = j;
			else
			    {
			    second_last = last;
			    last = j;
			    }
			}
		if (flag_check(orig_items[current->current->identity].slots,
		  FEET))
		    {
		    if (!(first==FEET))
			{
			if (last > FEET)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    strcat(message, "feet");
		    }
		if (flag_check(orig_items[current->current->identity].slots,
		  FOREARMS))
		    {
		    if (!(first==FOREARMS))
			{
			if (last > FOREARMS)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    strcat(message, "forearms");
		    }
		if (flag_check(orig_items[current->current->identity].slots,
		  PRIMARY_HAND))
		    {
		    if (!(first==PRIMARY_HAND))
			{
			if (last > PRIMARY_HAND)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    if (flag_check(flags, INV_LEFT_HANDED))
			strcat(message, "left");
		    else
			strcat(message, "right");
		    strcat(message, " hand");
		    }
		if (flag_check(orig_items[current->current->identity].slots,
		  SECONDARY_HAND))
		    {
		    if (!(first==SECONDARY_HAND))
			{
			if (last > SECONDARY_HAND)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    if (flag_check(flags, INV_LEFT_HANDED))
			strcat(message, "right");
		    else
			strcat(message, "left");
		    strcat(message, " hand");
		    }
		if (flag_check(orig_items[current->current->identity].slots,
		  HEAD))
		    {
		    if (!(first==HEAD))
			{
			if (last > HEAD)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    strcat(message, "head");
		    }
		if (flag_check(orig_items[current->current->identity].slots,
		  S_CLOAK))
		    {
		    if (!(first==S_CLOAK))
			{
			if (last > S_CLOAK)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    strcat(message, "body");
		    }
		if (flag_check(orig_items[current->current->identity].slots,
		  ARMOR))
		    {
		    if (!(first==ARMOR))
			{
			if (last > ARMOR)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    strcat(message, "torso");
		    }
		if (flag_check(orig_items[current->current->identity].slots,
		  VEHICLE))
		    {
		    if (!(first==VEHICLE))
			{
			if (last > VEHICLE)
			    {
			    strcat(message, ", ");
			    }
			else
			    {
			    if (first == second_last)
				strcat(message, " and ");
			    else
				strcat(message, ", and ");
			    }
			}
		    strcat(message, "use as vehicle");
		    }
		strcat(message, ")");
		}
	    if ((flag_check(current->current->flags, FINE_QUALITY)) &&
		(flag_check(current->current->flags, IDENTIFIED)))
		strcat(message, " (fine quality)");
	    else if ((flag_check(current->current->flags, POOR_QUALITY)) &&
		(flag_check(current->current->flags, IDENTIFIED)))
		strcat(message, " (poor quality)");
	    if (success)
		{
		if (flag_check(flags, FULLSCREEN))
		    success = fs_pmsg(message);
		else
		    pmsg(message);
		}
	    if (current->current->contents != NULL)
	    if ((((!(current->current->contents==NULL)) &&
	      (((flag_check(current->current->flags, IS_OPEN)) ||
	      (!(flag_check(current->current->flags, CAN_OPEN)))) ||
	      (flag_check(current->current->flags, TRANSLUCENT)))) &&
	      (success)) && flag_check(flags, INV_RECURSIVE))
		print_ilist_internal(current->current->contents, indent +
		  game_variables->indent_width, curr_letter, flags);
	    }
	}
    }

void print_clist(struct clist *c, long flags)
    {
    long curr_letter, success;
    struct clist *current;
    char message[256], creature_name[256], myresult[256];
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    success = 1;
    curr_letter = (long) 'a';
    if (!(c==NULL))
	{
	for (current=c; (!(current==NULL)); current = current->next)
	    {
	    if (!(current->current->name == NULL))
		strcpy(creature_name, current->current->name->text);
	    else if (!(current->current->extended == NULL))
		{
		strcpy(creature_name, current->current->extended->title);
		if ((creature_name[0] >= 'a') && (creature_name[0] <= 'z'))
		    creature_name[0] += 'A' - 'a';
		}
	    else
		strcpy(creature_name,
		  master_creatures[current->current->identity].species);
	    if (flag_check(flags, LETTER_ITEMS))
		sprintf(message, "%c: ", (char) curr_letter);
	    else
		strcpy(message, "");
	    if (current->current->extended==NULL)
		{
		if (!(flag_check(current->current->flags, UNIQUE)))
		    {
		    if (current->current->name == NULL)
			{
			strcat(message, "A");
			if ((creature_name[0] == 'a') ||
			    (creature_name[0] == 'e') ||
			    (creature_name[0] == 'i') ||
			    (creature_name[0] == 'o') ||
			    (creature_name[0] == 'u') ||
			    (creature_name[0] == 'A') ||
			    (creature_name[0] == 'E') ||
			    (creature_name[0] == 'I') ||
			    (creature_name[0] == 'O') ||
			    (creature_name[0] == 'U'))
			    strcat(message, "n ");
			else
			    strcat(message, " ");
			}
		    }
		else
		    strcat(message, "The ");
		}
	    curr_letter = successor(curr_letter);
	    strcat(message, creature_name);
	    if (flag_check(flags, LIST_PRICES))
		{
		strcat(message, " (");
		if (!(flag_check(current->current->flags, C_HAGGLED)))
		    strcat(message, "asking ");
		money_string(current->current->price, myresult);
		strcat(message, myresult);
		strcat(message, ")");
		}
	    if (success)
		{
		if (flag_check(flags, FULLSCREEN))
		    success = fs_pmsg(message);
		else
		    pmsg(message);
		}
	    }
	}
    }

void money_string(long amount, char *result)
    {

/* This will list roughly two denominations of coin, even if the exact */
/* amount is a little lower.  This is intended to give a somewhat human, */
/* approximate feel, as well as not boring the player with copper pieces */
/* for an item that costs about 40 gold. */

    long au, el, si, cu, first, last, second_last, i;
    char temp[256];
    first = 0;
    au = amount/AU;
    el = (amount - au*AU)/EL;
    si = (amount - au*AU - el*EL)/SI;
    cu = (amount - au*AU - el*EL - si*SI)/CU;
    strcpy(result, "");

/* We use i to keep track of the number of metals we have considered so far. */
/* Last and second last are the last and second last two metals; if there */
/* are only one or two, then they point to the same place. */

    if (au > 0)
	first = 1;
    else if (el > 0)
	first = 2;
    else if (si > 0)
	first = 3;
    else if (cu > 0)
	first = 4;
    if (au > 50)
	{
	second_last = last=1; /* gold */
	}
    else if (au > 10)
	{
	if (el > 0)
	    {
	    second_last = 1;
	    last = 2; /* electrum */
	    }
	else
	    second_last = last = 1;
	}
    else
	{
	if ((au > 0) || (el > 0))
	    {
	    if (si > 0)
		{
		last = 3; /* silver */
		if (el > 0)
		    second_last = 2;
		else
		    second_last = 1;
		}
	    else if (el > 0)
		{
		last = 2;
		if (au > 0)
		    second_last = 1;
		else
		    second_last = 2;
		}
	    else
		second_last = last = 1;
	    }
	else
	    {
	    if (cu > 0)
		{
		last = 4; /* copper */
		if (si > 0)
		    second_last = 3;
		else
		    second_last = 4;
		}
	    else
		{
		if (si > 0)
		    last = second_last = 3;
		else
		    last = second_last = 5; /* No money. */
		}
	    }
	}
    i=0;
    if (last == 5)
	strcpy(result, "free of charge");
    else
	{
	++i;
	if (au > 0)
	    {
	    sprintf(temp, "%ld gold", au);
	    strcat(result, temp);
	    if (last > i)
		{
		if (second_last == i)
		    {
		    if (second_last == first)
			strcat(result, " and ");
		    else
			strcat(result, ", and ");
		    }
		else
		    strcat(result, ", ");
		}
	    }
	++i;
	if ((el > 0) && (last >= 2))
	    {
	    sprintf(temp, "%ld electrum", el);
	    strcat(result, temp);
	    if (last > i)
		{
		if (second_last == i)
		    {
		    if (second_last == first)
			strcat(result, " and ");
		    else
			strcat(result, ", and ");
		    }
		else
		    strcat(result, ", ");
		}
	    }
	++i;
	if ((si > 0) && (last >= 3))
	    {
	    sprintf(temp, "%ld silver", si);
	    strcat(result, temp);
	    if (last > i)
		{
		if (second_last == i)
		    {
		    if (second_last == first)
			strcat(result, " and ");
		    else
			strcat(result, ", and ");
		    }
		else
		    strcat(result, ", ");
		}
	    }
	if ((cu > 0) && (last >= 4))
	    {
	    sprintf(temp, "%ld copper", cu);
	    strcat(result, temp);
	    }
	}
    }

void print_inventory(struct small_creature *c)
    {
    char message[256];
    long index_character;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c);
#endif
    clear();
    index_character = 'a';
    game_variables->fs_messages_printed = 0;
    if (!(c->extended == NULL))
	{
	fs_pmsg("Equipment in use:");
	fs_pmsg("");
	print_ilist_internal(c->extended->wear_wield, 0, &index_character,
	  LETTER_ITEMS|FULLSCREEN|LIST_SLOTS|INV_RECURSIVE);
	fs_pmsg("");
	fs_pmsg("Currently being carried:");
	fs_pmsg("");
	index_character = 'a';
	print_ilist_internal(c->extended->pack, 0, &index_character,
	  LETTER_ITEMS|FULLSCREEN|INV_RECURSIVE);
	if ((c->extended->au > 0) || (c->extended->el > 0) || (c->extended->si
	  > 0) || (c->extended->cu > 0))
	    {
	    fs_pmsg("");
	    if (c->extended->au > 0)
		{
		sprintf(message, "Gold: %ld", c->extended->au);
		fs_pmsg(message);
		}
	    if (c->extended->el > 0)
		{
		sprintf(message, "Electrum: %ld", c->extended->el);
		fs_pmsg(message);
		}
	    if (c->extended->si > 0)
		{
		sprintf(message, "Silver: %ld", c->extended->si);
		fs_pmsg(message);
		}
	    if (c->extended->cu > 0)
		{
		sprintf(message, "Copper: %ld", c->extended->cu);
		fs_pmsg(message);
		}
	    }
	fs_anykey();
	game_variables->fs_messages_printed = 0;
	refresh_screen();
	}
    }
