/**********************************************************************/
/* The Minstrel's Song is (c) 1998 by Jonathan Hayward.  See the file */
/* lib/copyrigh.txt for a copyright and license statement.            */
/**********************************************************************/

#include "tms.h"

void talk(struct small_creature *c1, struct small_creature *c2)
    {
    char message[256], message2[256];
    long my_flag, my_continue;;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    if ((c1 != NULL) && (c2 != NULL))
	{
	if (flag_check(c2->flags, HUMAN))
	    {
	    my_continue = TRUE;
	    while (my_continue)
		{
		clear();
		fs_pmsg("Talk: would you like to:");
		fs_pmsg("");
		fs_pmsg("a: greet");
		fs_pmsg("b: converse with");
		fs_pmsg("c: inquire about the profession of");
		fs_pmsg("d: trade with");
		fs_pmsg("e: request an action of");
		fs_pmsg("f: invite to follow you");
		fs_pmsg("g: say goodbye to");
		fs_pmsg("");
		find_title(c2, message);
		fs_pmsg(message);
		fs_pmsg("");
		switch(tgetc())
		    {
		    case 'a':
			clear();
			if (c2->extended != NULL)
			    switch(c2->extended->gender)
				{
				case MALE:
				    strcpy(message, "You give him ");
				    strcpy(message2, "He responds in kind.");
				break;
				case FEMALE:
				    strcpy(message, "You give her ");
				    strcpy(message2, "She responds in kind.");
				break;
				}
			else
			    switch(trandom() % 2)
				{
				case 0:
				    strcpy(message, "You give him ");
				    strcpy(message2, "He responds in kind.");
				break;
				case 1:
				    strcpy(message, "You give her ");
				    strcpy(message2, "She responds in kind.");
				break;
				}
			switch(c2->identity)
			    {
			    case JANRA:
				my_flag = TRUE;
				if (c2->extended != NULL)
				    {
				    if ((game_variables->current_quest ==
				      RECEIVED_GIFT) && (c2->extended->age_class ==
				      CHILD))
					{
					pmsg("The child gives you a flower.");
					acquire_item(c1, FLOWER);
					flag_set(&game_variables->quests_completed,
					  RECEIVED_GIFT);
					my_flag = FALSE;
					}
				    }
				if (my_flag)
				    switch(trandom()%4)
					{
					case 0:
					    strcat(message, "a sloppy, wet kiss.");
					break;
					case 1:
					    strcat(message, "a honk on the nose.");
					break;
					case 2:
					    strcat(message, "a floofing.");
					break;
					case 3:
					    strcat(message, "a tickling.");
					break;
					}
			    break;
			    case JEC:
				strcat(message, "your outstretched hand, and say, \"I give you my love.\"");
				fs_pmsg(message);
				strcpy(message, "The response comes, \"And I give you mine.\"");
			    break;
			    case NORKRIN:
				strcat(message, "a hand on the shoulder.");
			    break;
			    case SHAL:
				strcat(message, "a gentle embrace.");
			    break;
			    case TUZ:
				strcat(message, "a crushing bear hug");
				if (trandom() % 4 == 0)
				    strcat(message, ", and a punch in the stomach");
				strcat(message, ".");
			    break;
			    case URVANOVESTILLI:
				strcat(message, "a benediction, and three kisses on alternate cheeks.");
			    break;
			    case YEDIDIA:
				if (trandom() % 4 == 0)
				    strcat(message, "a butterfly kiss.");
				else
				    strcat(message, "a soft, gentle hug.");
			    break;
			    }
			fs_pmsg(message);
			fs_pmsg(message2);
		    break;
		    case 'b':
			clear();
			if (language_check(c1, c2->identity))
			    {
			    if (c2->extended != NULL)
				{
				switch(c2->extended->talk)
				    {
				    case TALK_JANRA:
					if (game_variables->current_quest ==
					  GUESSED_JANRA)
					    janra_guess();
					else
					    read_random_excerpt(FILE_QUOTES);
				    break;
				    case TALK_JEC: case TALK_NORKRIN: case
				    TALK_TUZ:
				    case TALK_URVANOVESTILLI: case TALK_YEDIDIA:
					read_random_excerpt(FILE_QUOTES);
				    break;
				    case TALK_SHAL:
					if (trandom() % 2)
					    fs_pmsg("You see a gentle smile.  ");
					else
					    read_random_excerpt(FILE_QUOTES);
				    break;
				    case TALK_CELEBRANT:
					talk_celebrant(c1, c2);
				    break;
				    case TALK_INTERCESSOR:
					talk_intercessor(c1, c2);
				    break;
				    case TALK_SERVER:
					talk_server(c1, c2);
				    break;
				    }
				}
			    else
				read_random_excerpt(FILE_QUOTES);
			    }
			else
			    {
			    clear();
			    read_random_excerpt(FILE_TRANSLATION_FAILED);
			    }
		    break;
		    case 'c':
			clear();
			fs_pmsg("");
			if (language_check(c1, c2->identity))
			    {
			    if (c2->extended != NULL)
				{
				switch(c2->extended->profession)
				    {
				    case ACROBAT:
					fs_pmsg("\"I am an acrobat.\"");
				    break;
				    case ANIMAL_HANDLER:
					fs_pmsg("\"I handle animals.\"");
				    break;
				    case ARCHER:
					fs_pmsg("\"I am an archer.\"");
				    break;
				    case BARD:
					fs_pmsg("\"I am a bard.\"");
				    break;
				    case HERBALIST:
					fs_pmsg("\"I am an herbalist.\"");
				    break;
				    case HUNTER:
					fs_pmsg("\"I am a hunter.\"");
				    break;
				    case INTERPRETER:
					fs_pmsg("\"I am an interpreter.\"");
				    break;
				    case JACK_OF_ALL_TRADES:
					fs_pmsg("\"I am really a jack of all trades.\"");
				    break;
				    case MAN_AT_ARMS:
					fs_pmsg("\"I study weapons and fighting art.\"");
				    break;
				    case MEDIC:
					fs_pmsg("\"I am a medic.\"");
				    break;
				    case MULTIPLE_PROFESSION:
				    fs_pmsg("\"I'm an adventurer, with a couple of different talents.\"");
				    break;
				    case SCHOLAR:
					fs_pmsg("\"I am a scholar.\"");
				    break;
				    case SCOUT:
					fs_pmsg("\"I am a scout.\"");
				    break;
				    case WOODSMAN:
					fs_pmsg("\"I am a woodsman.\"");
				    break;
				    case AFFIRMER:
					fs_pmsg("\"It is my responsibility to help other people be who they are meant to be, to");
					fs_pmsg("affirm them.\"");
				    break;
				    case ARTISAN:
					fs_pmsg("\"I'm simply an artisan.\"");
				    break;
				    case BAKER:
					fs_pmsg("\"I am a baker.\"");
				    break;
				    case BLACKSMITH:
					fs_pmsg("\"I am a blacksmith.\"");
				    break;
				    case BREWER:
					fs_pmsg("\"I am a brewer.\"");
				    break;
				    case CARPENTER:
					fs_pmsg("\"I am a carpenter.\"");
				    break;
				    case COBBLER:
					fs_pmsg("\"I am a cobbler.\"");
				    break;
				    case COOK:
					fs_pmsg("\"I am a cook.\"");
				    break;
				    case DEVICE_MAKER:
					fs_pmsg("\"I am a craftsman who makes devices.\"");
				    break;
				    case FARMER:
					fs_pmsg("\"I am a farmer.\"");
				    break;
				    case FISHERMAN:
					fs_pmsg("\"I am a fisherman.\"");
				    break;
				    case GARDENER:
					fs_pmsg("\"I am a gardener.\"");
				    break;
				    case MASON:
					fs_pmsg("\"I am a mason.\"");
				    break;
				    case MERCHANT:
					fs_pmsg("\"I am a merchant.\"");
				    break;
				    case MYSTIC:
					fs_pmsg("\"I am a mystic.\"");
				    break;
				    case PHILOSOPHER:
					fs_pmsg("\"I am a philosopher.\"");
				    break;
				    case POET:
					fs_pmsg("\"I am a poet.\"");
				    break;
				    case SAILOR:
					fs_pmsg("\"I am a sailor.\"");
				    break;
				    case SHEPHERD:
					fs_pmsg("\"I am a shepherd.\"");
				    break;
				    case TAILOR:
					fs_pmsg("\"I am a tailor.\"");
				    break;
				    case TANNER:
					fs_pmsg("\"I am a tanner.\"");
				    break;
				    case WEAVER:
					fs_pmsg("\"I am a weaver.\"");
				    break;
				    default:
					sprintf(message, "Error; out of range profession %ld!", c2->extended->profession);
				    break;
				    }
				}
			    else
				fs_pmsg("\"I do just this and that, really...\"");
			    }
			else
			    {
			    clear();
			    read_random_excerpt(FILE_TRANSLATION_FAILED);
			    }
		    break;
		    case 'd':
			if (language_check(c1, c2->identity))
			    {
			    talk_trade(c1, c2);
			    }
			else
			    {
			    clear();
			    read_random_excerpt(FILE_TRANSLATION_FAILED);
			    }
		    break;
		    case 'e':
			if (language_check(c1, c2->identity))
			    {
			    clear();
			    if (c1->extended != NULL)
				{
				if (c2->extended != NULL)
				    {
				    if (skill_check(c1,
				      c1->extended->skills->av[PERSUASION],
				      c2->extended->persuade_diff,
				      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
				      0)
					{
					pmsg("\"What would you like for me to do?\"");
					get_command(c2);
					}
				    }
				else
				    {
				    if (skill_check(c1,
				      c1->extended->skills->av[PERSUASION],
				      master_creatures[c2->identity].persuade_diff,
				      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
				      0)
					{
					pmsg("\"What would you like for me to do?\"");
					get_command(c2);
					}
				    }
				}
			    }
			else
			    {
			    clear();
			    read_random_excerpt(FILE_TRANSLATION_FAILED);
			    }
		    break;
		    case 'f':
			if (language_check(c1, c2->identity))
			    {
			    clear();
			    if (c1->extended != NULL)
				{
				if (c2->extended != NULL)
				    {
				    if (skill_check(c1,
				      c1->extended->skills->av[PERSUASION],
				      c2->extended->persuade_diff + ONE_NOTCH,
				      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
				      0)
					{
					pmsg("I'll follow you.");
					make_follow(c2, c1);
					}
				    else
					pmsg("I won't follow you for now.");
				    }
				else
				    {
				    if (skill_check(c1,
				      c1->extended->skills->av[PERSUASION],
				      master_creatures[c2->identity].persuade_diff +
				      ONE_NOTCH,
				      SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE) >
				      0)
					{
					pmsg("I'll follow you.");
					make_follow(c2, c1);
					}
				    else
					pmsg("I won't follow you for now.");
				    }
				}
			    }
			else
			    {
			    clear();
			    read_random_excerpt(FILE_TRANSLATION_FAILED);
			    }
		    break;
		    case 'g': case 'q': case ESCAPE:
			clear();
			pmsg("\"Goodbye!\"");
			my_continue = FALSE;
		    break;
		    }
		fs_anykey();
		}
	    }
	else
	    {
	    pmsg("What would you like to say to it?");
	    tgets(message);
	    }
	}
    }

long janra_guess()
    {
    char garbage[256];
    long my_continue;
    pmsg("The Janra says, \"Would you like to play a guessing game?\"");
    my_continue = confirm_silent();
    if (!(my_continue))
	return FALSE;
    while (my_continue)
	{
	pmsg("\"Ask me a yes/no question.\"");
	tgets(garbage);
	switch(trandom() % 2)
	    {
	    case 0:
		pmsg("\"No.\"");
	    break;
	    case 1:
		pmsg("\"Yes.\"");
	    break;
	    }
	pmsg("\"Would you like to ask me another question?\"");
	my_continue = confirm_silent();
	}
    return TRUE;
    }

void talk_celebrant(struct small_creature *c1, struct small_creature *c2)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    fs_pmsg("\"Hello.  We have worship services every hour.  Would you like for me to pray");
    fs_pmsg("with you?\"");
    if (confirm_silent())
	talk_intercessor(c1, c2);
    }

void talk_intercessor(struct small_creature *c1, struct small_creature *c2)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    clear();
    fs_pmsg("\"Greetings.  Would you like for me to:");
    fs_pmsg("");
    fs_pmsg("a: \"bless you,");
    fs_pmsg("b: pray for healing, or");
    fs_pmsg("c: pray together with you over a request you may have?\"");
    switch(tgetc())
	{
	case 'a':
	    clear();
	    fs_pmsg("May the Lord bless you richly.");
	    if (status_check(c1, STATUS_MIRACLE_PROVIDENCE) < 3)
		status_add(c1, STATUS_MIRACLE_PROVIDENCE, 1);
	break;
	case 'b':
	    fs_pmsg("Lord, impart your healing.");
	    healing(c1, 1);
	break;
	case 'c':
	    pray(c1, ONE_NOTCH);
	break;
	}
    }

void talk_server(struct small_creature *c1, struct small_creature *c2)
    {
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    if (current_level->establishment != NULL)
	p_establishment(c1, TAVERN, current_level->establishment);
    }

void talk_trade(struct small_creature *c1, struct small_creature *c2)
    {
    char message[256], temp[256];
    struct small_item *curr_item;
    struct ilist *curr_ilist, *traverse;
    long my_continue, foo, success_haggling, i, offer, selection_char, markup,
      buyback;
#ifdef DEBUG
    check_pointer((struct pointer_struct *) c1);
    check_pointer((struct pointer_struct *) c2);
#endif
    if ((c1 != NULL) && (c2 != NULL))
	if ((c1->extended != NULL) && (c2->extended != NULL))
	    {
	    switch(c2->identity)
		{
		case JANRA:
		    markup = 50;
		    buyback = 30;
		break;
		case JEC:
		    markup = 20;
		    buyback = 50;
		break;
		case NORKRIN:
		    markup = 30;
		    buyback = 40;
		break;
		case SHAL:
		    markup = 20;
		    buyback = 40;
		break;
		case TUZ:
		    markup = 50;
		    buyback = 60;
		break;
		case URVANOVESTILLI:
		    markup = 150;
		    buyback = 20;
		break;
		case YEDIDIA:
		    markup = 75;
		    buyback = 30;
		break;
		default:
		    markup = 50;
		    buyback = 50;
#ifdef DEBUG
pmsg("Talk_trade() called on creature of inappropriate race.");
#endif
		break;
		}
	    if (c2->extended->pack != NULL)
		for(traverse = c2->extended->pack; traverse != NULL; traverse =
		  traverse->next)
		    if (traverse->current->price == 0)
			traverse->current->price = random_adjust((((traverse->
			  current->value * (100 + markup))/100)*(100 +
			  markup))/100);
	    my_continue = TRUE;
	    while (my_continue)
		{
		game_variables->fs_messages_printed = 0;
		clear();
		fs_pmsg("You are trading with someone.");
		fs_pmsg("");
		fs_pmsg("You may:");
		fs_pmsg("");
		fs_pmsg("a: inquire about his inventory");
		if (c2->extended->gender == MALE)
		    fs_pmsg("b: haggle over the price of an item he has");
		else
		    fs_pmsg("b: haggle over the price of an item she has");
		fs_pmsg("c: purchase an item");
		fs_pmsg("d: haggle over the price of an item which you wish to sell.");
		fs_pmsg("e: sell an item");
		fs_pmsg("f: quit trading");
		fs_pmsg("i: look at your inventory");
		fs_pmsg("");
		switch(tgetc())
		    {
		    case 'a':
			clear();
			foo = 'a';
			game_variables->fs_messages_printed = 0;
			print_inventory(c2);
			fs_anykey();
		    break;
		    case 'b':
			fs_pmsg("");
			foo = 'a';
			fs_pmsg("Which item?");
			selection_char = tgetc();
			curr_item = find_item(&c2->extended->pack,
			  selection_char, 0);
			if (curr_item == NULL)
			    fs_pmsg("That is not a valid item.");
			else
			    {
			    if (flag_check(curr_item->flags2, HAGGLED))
				fs_pmsg("You have already haggled over the price of that item.");
			    else
				{
				flag_set(&curr_item->flags2, HAGGLED);
				success_haggling = min(4,
				  skill_check(c1,
				    c1->extended->skills->av[HAGGLING],
				    c2->extended->skills->av[HAGGLING],
				    SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE));
				if (success_haggling <= 0)
				    fs_pmsg("You aren't able to bring the price down at all.");
				else
				    {
				    for(i=0; i < success_haggling; ++i)
					curr_item->price = (curr_item->price *
					  100) / (100 + markup);
				    curr_item->price =
				      random_adjust(curr_item->price);
				    money_string(curr_item->price, temp);
				    sprintf(message, "You haggle the price down to %s.", temp);
				    fs_pmsg(message);
				    }
				}
			    }
			fs_anykey();
		    break;
		    case 'c':
			fs_pmsg("");
			fs_pmsg("Which item?");
			selection_char = tgetc();
			foo = 'a';
			curr_item = find_item(&c2->extended->pack,
			  selection_char, 0);
			if (curr_item == NULL)
			    fs_pmsg("That is not a valid item.");
			else
			    {
			    if (!(deduct_amount(c1, curr_item->price)))
				fs_pmsg("You don't quite have enough money.");
			    else
				{
				add_amount(c2, curr_item->price);
				foo = 'a';
				flag_reset(&curr_item->flags2, HAGGLED);
				extract_item(&c2->extended->pack, 'a',
				  &foo, selection_char,
				  EXTRACT_REMOVE_ITEM);
				find_and_remove_item(curr_item,
				  &c2->extended->pack);
				add_item(&c1->extended->pack, curr_item);
				if (c1==player)
				    {
				    clear();
				    pmsg("You put it in your pack...");
				    }
				calc_ready(c1);
				calc_ready(c2);
				}
			    }
			fs_anykey();
		    break;
		    case 'd':
			fs_pmsg("");
			fs_pmsg("Which item (from your pack)?");
			selection_char = tgetc();
			foo = 'a';
			curr_item = find_item(&c1->extended->pack,
			  selection_char, EXTRACT_RECURSIVE);
			if (curr_item == NULL)
			    fs_pmsg("That is not a valid item.");
			else
			    if (flag_check(curr_item->flags2, HAGGLED))
			    fs_pmsg("You have already haggled over the price of that item.");
			else
			    {

/*
 *
 * Shops will only pay half as much for items which are not identified.
 *
 */

				offer = 1 + (((curr_item->value * (100 -
				  buyback))/100) * (100 - buyback))/100/(1 +
				  flag_check(curr_item->flags, IDENTIFIED));
				money_string(offer, temp);
				curr_item->price = offer;
				if (c2->extended->gender == MALE)
				    sprintf(message, "He offers you %s for it.", temp);
				else
				    sprintf(message, "She offers you %s for it.", temp);
				fs_pmsg(message);
				flag_set(&curr_item->flags2, HAGGLED);
				success_haggling = min(4,
				  skill_check(c1, c1->extended->skills->av[HAGGLING],
				  c2->extended->skills->av[HAGGLING], SKILL_CHECK_CRITICAL_SUCCESS_GAIN_EXPERIENCE));
				if (success_haggling <= 0)
				    fs_pmsg("You aren't able to bring the price up at all.");
				else
				    {
				    for(i=0; i < success_haggling; ++i)
					curr_item->price = (curr_item->price * 100)
					  / (100 - buyback);
				    curr_item->price =
				      random_adjust(curr_item->price);
				    money_string(curr_item->price, temp);
				    sprintf(message,
				      "You haggle the price up to %s.", temp);
				    fs_pmsg(message);
				    flag_set(&curr_item->flags2, HAGGLED);
				    }
				}
			fs_anykey();
		    break;
		    case 'e':
			fs_pmsg("");
			fs_pmsg("Which item (from your pack)?");
			selection_char = tgetc();
			foo = 'a';
			curr_item = find_item(&c1->extended->pack, selection_char,
			  EXTRACT_RECURSIVE);
			if (curr_item == NULL)
			    fs_pmsg("That is not a valid item.");
			else
			    if (!(flag_check(curr_item->flags2, HAGGLED)))
				pmsg("You have not haggled over that item");
			    else if (!(deduct_amount(c2, curr_item->price)))
				{
				if (c2->extended->gender == MALE)
				    pmsg("He doesn't have enough money.");
				else
				    pmsg("She doesn't have enough money.");
				}
			    else
				{
				add_amount(c1, curr_item->price);
				curr_item = extract_item(&c1->extended->pack, 'a',
				  &foo, selection_char, EXTRACT_REMOVE_ITEM);
				find_and_remove_item(curr_item,
				  &c1->extended->pack);
				curr_ilist = (struct ilist *) calloc(1,
				  sizeof(struct ilist));
#ifdef DEBUG
				curr_ilist->me = curr_ilist;
#endif
				curr_ilist->next = c2->extended->pack;
				curr_ilist->current = curr_item;
				c2->extended->pack = curr_ilist;
				fs_pmsg("Sold!");
				}
			fs_anykey();
		    break;
		    case 'i':
			print_inventory(c1);
		    break;
		    case 'q': case 'x': case ESCAPE: case 'f':
			my_continue = 0;
		    break;
		    }
		}
	    clear();
	    }
    }
